<?php
if ( ! class_exists( 'Medical_Store_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Medical_Store_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Medical_Store_Plugin_Activation_WPElemento_Importer {

        private static $medical_store_instance;
        public $medical_store_action_count;
        public $medical_store_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$medical_store_instance) ) {
            self::$medical_store_instance = new self();
          }
          return self::$medical_store_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'medical_store_recommended_plugins', array($this, 'medical_store_recommended_elemento_importer_plugins_array') );

            $medical_store_actions                   = $this->medical_store_get_recommended_actions();
            $this->medical_store_action_count        = $medical_store_actions['count'];
            $this->medical_store_recommended_actions = $medical_store_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function medical_store_recommended_elemento_importer_plugins_array($medical_store_plugins){
            $medical_store_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'medical-store'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'medical-store'),               
            );
            return $medical_store_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'medical-store-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('medical-store-plugin-activation-script', 'medical_store_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'medical-store'),
                    'activating' => esc_html__('Activating', 'medical-store'),
                    'error' => esc_html__('Error', 'medical-store'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'medical-store-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function medical_store_get_recommended_actions() {

            $medical_store_act_count  = 0;
            $medical_store_actions_todo = get_option( 'recommending_actions', array());

            $medical_store_plugins = $this->medical_store_get_recommended_plugins();

            if ($medical_store_plugins) {
                foreach ($medical_store_plugins as $medical_store_key => $medical_store_plugin) {
                    $medical_store_action = array();
                    if (!isset($medical_store_plugin['slug'])) {
                        continue;
                    }

                    $medical_store_action['id']   = 'install_' . $medical_store_plugin['slug'];
                    $medical_store_action['desc'] = '';
                    if (isset($medical_store_plugin['desc'])) {
                        $medical_store_action['desc'] = $medical_store_plugin['desc'];
                    }

                    $medical_store_action['name'] = '';
                    if (isset($medical_store_plugin['name'])) {
                        $medical_store_action['title'] = $medical_store_plugin['name'];
                    }

                    $medical_store_link_and_is_done  = $this->medical_store_get_plugin_buttion($medical_store_plugin['slug'], $medical_store_plugin['name'], $medical_store_plugin['function']);
                    $medical_store_action['link']    = $medical_store_link_and_is_done['button'];
                    $medical_store_action['is_done'] = $medical_store_link_and_is_done['done'];
                    if (!$medical_store_action['is_done'] && (!isset($medical_store_actions_todo[$medical_store_action['id']]) || !$medical_store_actions_todo[$medical_store_action['id']])) {
                        $medical_store_act_count++;
                    }
                    $medical_store_recommended_actions[] = $medical_store_action;
                    $medical_store_actions_todo[]        = array('id' => $medical_store_action['id'], 'watch' => true);
                }
                return array('count' => $medical_store_act_count, 'actions' => $medical_store_recommended_actions);
            }

        }

        public function medical_store_get_recommended_plugins() {

            $medical_store_plugins = apply_filters('medical_store_recommended_plugins', array());
            return $medical_store_plugins;
        }

        public function medical_store_get_plugin_buttion($slug, $name, $function) {
                $medical_store_is_done      = false;
                $medical_store_button_html  = '';
                $medical_store_is_installed = $this->is_plugin_installed($slug);
                $medical_store_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $medical_store_is_activeted = (class_exists($function)) ? true : false;
                if (!$medical_store_is_installed) {
                    $medical_store_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $medical_store_plugin_install_url = wp_nonce_url($medical_store_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $medical_store_button_html        = sprintf('<a class="medical-store-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($medical_store_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'medical-store'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'medical-store')
                    );
                } elseif ($medical_store_is_installed && !$medical_store_is_activeted) {

                    $medical_store_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($medical_store_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $medical_store_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $medical_store_button_html = sprintf('<a class="medical-store-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($medical_store_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'medical-store'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'medical-store')
                    );
                } elseif ($medical_store_is_activeted) {
                    $medical_store_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'medical-store'));
                    $medical_store_is_done     = true;
                }

                return array('done' => $medical_store_is_done, 'button' => $medical_store_button_html);
            }
        public function is_plugin_installed($slug) {
            $medical_store_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $medical_store_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($medical_store_installed_plugins[$medical_store_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $medical_store_keys = array_keys($this->get_installed_plugins());
            foreach ($medical_store_keys as $medical_store_key) {
                if (preg_match('|^' . $slug . '/|', $medical_store_key)) {
                    return $medical_store_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Medical_Store_Plugin_Activation_WPElemento_Importer::get_instance();